︠4d4ef149-857b-4b96-b5dd-152ccc58c4c0i︠
%html
<h1 style="text-align: right;"><span style="font-weight: normal; font-size: small;">Christos Saragiotis</span></h1>
<p><span style="font-family: 'book antiqua', palatino;">In this worksheet I present two interactive examples of Fourier series. The aim is to demonstrate&nbsp;</span></p>
<ol>
<li><span style="font-family: 'book antiqua', palatino;">the more terms&nbsp;included in the truncated Fourier Series, the better the approximation of the original signal and &nbsp; &nbsp;</span></li>
<li><span style="font-family: 'book antiqua', palatino;">the Gibbs phenomenon close to the discontinuities.</span></li>
</ol>
<h2>1. Square wave</h2>
<p><span style="font-family: 'book antiqua', palatino;">We define the square wave with period $T_0$ as</span></p>
<p><span style="font-family: 'book antiqua', palatino;">$$ p(t) = A\mathrm{sign}\left[\sin\left(2\pi \frac{t}{T_0}\right)\right] $$&nbsp;</span></p>

︡bafe445e-4805-4bec-954f-23fdfdcb7d69︡{"html": "<h1 style=\"text-align: right;\"><span style=\"font-weight: normal; font-size: small;\">Christos Saragiotis</span></h1>\n<p><span style=\"font-family: 'book antiqua', palatino;\">In this worksheet I present two interactive examples of Fourier series. The aim is to demonstrate&nbsp;</span></p>\n<ol>\n<li><span style=\"font-family: 'book antiqua', palatino;\">the more terms&nbsp;included in the truncated Fourier Series, the better the approximation of the original signal and &nbsp; &nbsp;</span></li>\n<li><span style=\"font-family: 'book antiqua', palatino;\">the Gibbs phenomenon close to the discontinuities.</span></li>\n</ol>\n<h2>1. Square wave</h2>\n<p><span style=\"font-family: 'book antiqua', palatino;\">We define the square wave with period $T_0$ as</span></p>\n<p><span style=\"font-family: 'book antiqua', palatino;\">$$ p(t) = A\\mathrm{sign}\\left[\\sin\\left(2\\pi \\frac{t}{T_0}\\right)\\right] $$&nbsp;</span></p>"}︡
︠e503ca16-909b-4b36-b3fd-281fd64d9939︠
pi = float(pi)

A=1
P=2
def pulse(t):
    # Periodic pulse train.
    # A: amplitude
    # P: period
    return A*sgn(sin(2*pi*t/P))  


plot(pulse,(-5,5), ymin=-2*A, ymax=2*A)
︡905d627c-b75b-4a4a-9542-03185f5590bc︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠c14a5ddc-8183-4c4a-8d5a-937de19f025bi︠
%html
<p><span style="font-family: 'book antiqua', palatino;">The Fourier series coefficients of $p(t)$ are</span></p>
<ul>
<li><span style="font-family: 'book antiqua', palatino;">$a_0 = \displaystyle\frac{2}{T_0}\int_{T_0}p(t)\;dt = 0$,</span></li>
<li><span style="font-family: 'book antiqua', palatino;">$a_n = 0$, for $n\geq1$ due to the odd symmetry and</span></li>
<li><span style="font-family: 'book antiqua', palatino;">$b_n = \displaystyle\frac{2}{T_0}\int_{T_0}p(t)\sin\left(n\omega_0t\right)\;dt = \frac{2A\left(1-\cos(n\pi)\right)}{n\pi}$, for $n \geq 1$.</span></li>
</ul>

︡3a7a2845-dd44-4ee5-a9a4-188adfe3289e︡{"html": "<p><span style=\"font-family: 'book antiqua', palatino;\">The Fourier series coefficients of $p(t)$ are</span></p>\n<ul>\n<li><span style=\"font-family: 'book antiqua', palatino;\">$a_0 = \\displaystyle\\frac{2}{T_0}\\int_{T_0}p(t)\\;dt = 0$,</span></li>\n<li><span style=\"font-family: 'book antiqua', palatino;\">$a_n = 0$, for $n\\geq1$ due to the odd symmetry and</span></li>\n<li><span style=\"font-family: 'book antiqua', palatino;\">$b_n = \\displaystyle\\frac{2}{T_0}\\int_{T_0}p(t)\\sin\\left(n\\omega_0t\\right)\\;dt = \\frac{2A\\left(1-\\cos(n\\pi)\\right)}{n\\pi}$, for $n \\geq 1$.</span></li>\n</ul>"}︡
︠f288d545-13f5-4030-8645-b17d606c305e︠
def Pulse(N):    # FS coeffs of pulse
    a0 = 0
    an = [A*0 for n in [1..N]]
    bn = [2*A/(pi*n)*(1 - cos(n*pi)) for n in [1..N]]
    return (a0,an,bn)
︡52df9af6-abbf-4aaa-89b9-461433cab634︡︡
︠1c374699-f4f2-4dc1-8cc7-6d9cc94827c1i︠
%html
<p><span style="font-family: 'book antiqua', palatino;">The Fourier Series sum is</span></p>
<p><span style="font-family: 'book antiqua', palatino;">$$p(t) \sim \sum_{n=1}^\infty b_n\sin\left(n\omega_0t\right) = \sum_{n=1}^\infty b_n\sin\left(n\frac{2\pi}{T_0}t\right)$$</span></p>
<p><span style="font-family: 'book antiqua', palatino;">and the partial sum of $N$ terms</span></p>
<p><span style="font-family: 'book antiqua', palatino;">$$p_N(t) = \sum_{n=1}^N b_n\sin\left(n\frac{2\pi}{T_0}t\right)$$</span></p>

︡5fb3efa9-bab9-469c-abc0-e84ab3649f34︡{"html": "<p><span style=\"font-family: 'book antiqua', palatino;\">The Fourier Series sum is</span></p>\n<p><span style=\"font-family: 'book antiqua', palatino;\">$$p(t) \\sim \\sum_{n=1}^\\infty b_n\\sin\\left(n\\omega_0t\\right) = \\sum_{n=1}^\\infty b_n\\sin\\left(n\\frac{2\\pi}{T_0}t\\right)$$</span></p>\n<p><span style=\"font-family: 'book antiqua', palatino;\">and the partial sum of $N$ terms</span></p>\n<p><span style=\"font-family: 'book antiqua', palatino;\">$$p_N(t) = \\sum_{n=1}^N b_n\\sin\\left(n\\frac{2\\pi}{T_0}t\\right)$$</span></p>"}︡
︠9dddcce0-e6c1-4b66-ad3d-7d7bb8fd04bd︠
def Partial_sum(t, coeffs):
   # Evaluate the Fourier series with coefficients coeffs.
   partial(t) = coeffs[0]
   N = len(coeffs[1])
   for n,an,bn in zip(range(1,N+1), coeffs[1],coeffs[2]):
       partial(t) = partial(t) + an*cos(n*2*pi/P*t) + bn*sin(n*2*pi/P*t)
   return partial

    
@interact
def show_sum(N=(0,(0..100))):
    coeffs = Pulse(N)
    fn = Partial_sum(t, coeffs)
    p1 = plot(pulse, (-2.5,2.5), color='blue')
    p2 = plot(fn, (-2.5,2.5), color='green')
    txt = text("pulse train and FS partial sum", (3,2*A), horizontal_alignment='right', color='black')
    show(p2+p1+txt)
︡6c4ff2fe-63d2-4c69-98de-befeca018855︡︡
︠da12b6bd-4338-433d-a387-d3d9aabdb996i︠
%html
<h2>2. Sawtooth wave</h2>
<p><span style="font-family: 'book antiqua', palatino;">Let the sawtooth wave be</span></p>
<p><span style="font-family: 'book antiqua', palatino;">$$ s(t) = A\left(\frac{t}{T_0} - \left\lfloor \frac{t}{T_0}\right\rfloor\right),\quad t\in\mathbb{R}$$</span></p>

︡fff3b41b-5479-45a5-bc9f-ef6eb99d9ffb︡{"html": "<h2>2. Sawtooth wave</h2>\n<p><span style=\"font-family: 'book antiqua', palatino;\">Let the sawtooth wave be</span></p>\n<p><span style=\"font-family: 'book antiqua', palatino;\">$$ s(t) = A\\left(\\frac{t}{T_0} - \\left\\lfloor \\frac{t}{T_0}\\right\\rfloor\\right),\\quad t\\in\\mathbb{R}$$</span></p>"}︡
︠4692b834-a6ad-4c87-ba55-09996e145463︠
var('t')
A = 1
P = 2

def sawtooth(t):
    return A*((t/P) - floor((t/P)))

plot(sawtooth, (-5,5), ymax=A+1)
︡8de25e1b-e4cf-4ec5-81f3-8a86b543dbbd︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠eeacfdaa-0774-4eaf-a1cd-5064e5c726cfi︠
%html
<div style="color: #000000; background-image: initial; background-attachment: initial; background-origin: initial; background-clip: initial; background-color: #ffffff; background-position: initial initial; background-repeat: initial initial; margin: 8px;">
<p><span style="font-family: 'book antiqua', palatino;">The Fourier series coefficients of $s(t)$ are</span></p>
<ul>
<li><span style="font-family: 'book antiqua', palatino;">$a_0 = \displaystyle\frac{2}{T_0}\int_{T_0}s(t)\;dt = \frac{2}{T_0}\int_0^{T_0}\frac{At}{T_0}\;dt =\frac{A}{2}$,</span></li>
<li><span style="font-family: 'book antiqua', palatino;">$a_n = 0$, for $n\geq 1$ due to the (hidden) odd symmetry.</span></li>
<li><span style="font-family: 'book antiqua', palatino;">$b_n = \frac{2}{T_0}\displaystyle\int_{T_0}s(t)\sin\left(n\omega_0t\right)\;dt = -\frac{A}{n\pi}$, for $n \geq 1$.</span></li>
</ul>
</div>

︡aac144ce-738f-4b85-9fa9-e13d0192e7f1︡{"html": "<div style=\"color: #000000; background-image: initial; background-attachment: initial; background-origin: initial; background-clip: initial; background-color: #ffffff; background-position: initial initial; background-repeat: initial initial; margin: 8px;\">\n<p><span style=\"font-family: 'book antiqua', palatino;\">The Fourier series coefficients of $s(t)$ are</span></p>\n<ul>\n<li><span style=\"font-family: 'book antiqua', palatino;\">$a_0 = \\displaystyle\\frac{2}{T_0}\\int_{T_0}s(t)\\;dt = \\frac{2}{T_0}\\int_0^{T_0}\\frac{At}{T_0}\\;dt =\\frac{A}{2}$,</span></li>\n<li><span style=\"font-family: 'book antiqua', palatino;\">$a_n = 0$, for $n\\geq 1$ due to the (hidden) odd symmetry.</span></li>\n<li><span style=\"font-family: 'book antiqua', palatino;\">$b_n = \\frac{2}{T_0}\\displaystyle\\int_{T_0}s(t)\\sin\\left(n\\omega_0t\\right)\\;dt = -\\frac{A}{n\\pi}$, for $n \\geq 1$.</span></li>\n</ul>\n</div>"}︡
︠20fc15aa-ffe7-49d8-a8d6-b7be75831ff2︠
def Sawtooth(N):    # FS coeffs of pulse
    a0 = A/2
    an = [A*0 for n in [1..N]]
    bn = [-A/(pi*n) for n in [1..N]]
    return (a0,an,bn)
︡e49e8a50-08c5-448d-97e6-b4ec8f9f1b4a︡︡
︠c9bca8d6-3f53-413b-b9f5-cda12fc33723i︠
%html
<div style="color: #000000; background-image: initial; background-attachment: initial; background-origin: initial; background-clip: initial; background-color: #ffffff; background-position: initial initial; background-repeat: initial initial; margin: 8px;">
<p><span style="font-family: 'book antiqua', palatino;">The Fourier Series sum is</span></p>
<p><span style="font-family: 'book antiqua', palatino;">$$s(t) \sim \frac{a_0}{2} + \sum_{n=1}^\infty b_n\sin\left(n\omega_0t\right) = \sum_{n=1}^\infty b_n\sin\left(n\frac{2\pi}{T_0}t\right)$$</span></p>
<p><span style="font-family: 'book antiqua', palatino;">and the partial sum of $N$ terms</span></p>
<p><span style="font-family: 'book antiqua', palatino;">$$s_N(t) = \sum_{n=1}^N b_n\sin\left(n\frac{2\pi}{T_0}t\right)$$</span></p>
</div>

︡53600cb5-5fed-4831-a63b-5b8d71a3ff10︡{"html": "<div style=\"color: #000000; background-image: initial; background-attachment: initial; background-origin: initial; background-clip: initial; background-color: #ffffff; background-position: initial initial; background-repeat: initial initial; margin: 8px;\">\n<p><span style=\"font-family: 'book antiqua', palatino;\">The Fourier Series sum is</span></p>\n<p><span style=\"font-family: 'book antiqua', palatino;\">$$s(t) \\sim \\frac{a_0}{2} + \\sum_{n=1}^\\infty b_n\\sin\\left(n\\omega_0t\\right) = \\sum_{n=1}^\\infty b_n\\sin\\left(n\\frac{2\\pi}{T_0}t\\right)$$</span></p>\n<p><span style=\"font-family: 'book antiqua', palatino;\">and the partial sum of $N$ terms</span></p>\n<p><span style=\"font-family: 'book antiqua', palatino;\">$$s_N(t) = \\sum_{n=1}^N b_n\\sin\\left(n\\frac{2\\pi}{T_0}t\\right)$$</span></p>\n</div>"}︡
︠d5beca55-4a47-4a8d-85ae-12251973f2e2︠
@interact
def show_sum(N=(0,(0..100))):
    coeffs = Sawtooth(N)
    fn = Partial_sum(t, coeffs)
    p3 = plot(sawtooth, (-2.5,2.5), color='blue')
    p4 = plot(fn, (-2.5,2.5), color='green')
    txt = text("sawtooth wave and FS partial sum", (3,A+1), horizontal_alignment='right', color='black')
    show(p3+p4+txt)
︡41dde566-4dde-4ce3-90df-6498b8f49b98︡︡
